//
// Copyright  2001 Rui Godinho Lopes <ruiglopes@yahoo.com>
// All rights reserved.
//
// This source file(s) may be redistributed unmodified by any means
// PROVIDING they are not sold for profit without the authors expressed
// written consent, and providing that this notice and the authors name
// and all copyright notices remain intact.
//
// Any use of the software in source or binary forms, with or without
// modification, must include, in the user documentation ("About" box and
// printed documentation) and internal comments to the code, notices to
// the end user as follows:
//
// "Portions Copyright  2001 Rui Godinho Lopes"
//
// An email letting me know that you are using it would be nice as well.
// That's not much to ask considering the amount of work that went into
// this.
//
// THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS OR IMPLIED. USE IT AT YOUT OWN RISK. THE AUTHOR ACCEPTS NO
// LIABILITY FOR ANY DATA DAMAGE/LOSS THAT THIS PRODUCT MAY CAUSE.
//

// perpixelalphaDlg.cpp : implementation file
//

#include "stdafx.h"
#include "perpixelalpha.h"
#include "DummyDialog.h"
#include "perpixelalphaDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "PSPLoader.h"
#include "imgdecoder.h"

/** @author Rui Godinho Lopes <ruiglopes@yahoo.com>
	*/
void PreMultiplyRGBChannels(CBitmap &bmp, LPBYTE pBitmapBits)
{
	BITMAP bmpInfo;
	bmp.GetBitmap(&bmpInfo);

	// pre-multiply rgb channels with alpha channel
	for (int y=0; y<bmpInfo.bmHeight; ++y)
	{
		BYTE *pPixel= pBitmapBits + bmpInfo.bmWidth * 4 * y;

		for (int x=0; x<bmpInfo.bmWidth ; ++x)
		{
			pPixel[0]= pPixel[0]*pPixel[3]/255;
			pPixel[1]= pPixel[1]*pPixel[3]/255;
			pPixel[2]= pPixel[2]*pPixel[3]/255;

			pPixel+= 4;
		}
	}
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPerpixelalphaDlg dialog

CPerpixelalphaDlg::CPerpixelalphaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPerpixelalphaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPerpixelalphaDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pImg= NULL;
	m_pImgDecoder= NULL;
}

CPerpixelalphaDlg::~CPerpixelalphaDlg()
{
	::ImgDeleteDIBSection(m_pImg);
	::ImgDeleteDecoder(m_pImgDecoder);
}


void CPerpixelalphaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPerpixelalphaDlg)
	DDX_Control(pDX, IDC_LEVEL, m_wndLevel);
	DDX_Control(pDX, IDC_SLIDER, m_wndSlider);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPerpixelalphaDlg, CDialog)
	//{{AFX_MSG_MAP(CPerpixelalphaDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DROPFILES()
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPerpixelalphaDlg message handlers

BOOL CPerpixelalphaDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	::ImgNewDecoder(&m_pImgDecoder);

	// creates the dummy dialog modeless
	m_dlgDummy.Create(CDummyDialog::IDD);
	m_dlgDummy.ShowWindow(SW_SHOW);

	m_wndSlider.SetRange(0, 255);
	m_wndSlider.SetPos(255);

	DragAcceptFiles();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPerpixelalphaDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPerpixelalphaDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPerpixelalphaDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPerpixelalphaDlg::DoUpdateDummyDialog(CWnd &wnd, CBitmap &bmp, BYTE SourceConstantAlpha/*= 255*/)
{
	// make sure the window has the WS_EX_LAYERED style
	wnd.ModifyStyleEx(0, WS_EX_LAYERED);


	// ok... into the per-pixel-alpha bendling....

	// Create/setup the DC's

	CDC dcScreen;
	CDC dcMemory;

	dcScreen.Attach(::GetDC(NULL));
	dcMemory.CreateCompatibleDC(&dcScreen);

	CBitmap *pOldBitmap= dcMemory.SelectObject(&bmp);


	// get the bitmap dimensions
	BITMAP bmpInfo;
	bmp.GetBitmap(&bmpInfo);

	// get the window rectangule (we are only interested in the top left position)
	CRect rectDlg;
	wnd.GetWindowRect(rectDlg);

	// calculate the new window position/size based on the bitmap size
	CPoint ptWindowScreenPosition(rectDlg.TopLeft());
	CSize szWindow(bmpInfo.bmWidth, bmpInfo.bmHeight);


	// Perform the alpha blend

	// setup the blend function
	BLENDFUNCTION blendPixelFunction= { AC_SRC_OVER, 0, SourceConstantAlpha, AC_SRC_ALPHA };
	CPoint ptSrc(0,0); // start point of the copy from dcMemory to dcScreen

	// perform the alpha blend
	BOOL bRet= ::UpdateLayeredWindow(wnd, dcScreen, &ptWindowScreenPosition, &szWindow, dcMemory,
		&ptSrc, 0, &blendPixelFunction, ULW_ALPHA);

	ASSERT(bRet); // ops... something bad just occured....

	// clean up
	dcMemory.SelectObject(pOldBitmap);


	// update the dialog label with the current opacity value
	TCHAR buf[10];
	::_itot(SourceConstantAlpha, buf, 10);
	m_wndLevel.SetWindowText(buf);
}

void CPerpixelalphaDlg::OnDropFiles(HDROP hDropInfo) 
{
	TCHAR buf[2048];
	::DragQueryFile(hDropInfo, 0, buf, 2048);
	::DragFinish(hDropInfo);

	DoLoadFile(buf);
	
	//CDialog::OnDropFiles(hDropInfo);
}

void CPerpixelalphaDlg::DoLoadFile(LPCTSTR pFileName)
{
	CWaitCursor wait;

	HBITMAP hBitmap;
	LPBYTE pBitmapBits;
	LPVOID pImg= NULL;

	// first try to load with paintlib....
	if (!::ImgNewDIBFromFile(m_pImgDecoder, pFileName, &pImg))
	{
		::ImgGetHandle(pImg, &hBitmap, (LPVOID *)&pBitmapBits);

		// get the bitmap info
		BITMAP bmpInfo;
		::GetObject(hBitmap, sizeof(BITMAP), &bmpInfo);

		if (bmpInfo.bmBitsPixel != 32)
		{
			::ImgDeleteDIBSection(pImg);
			::AfxMessageBox(IDS_ERRORLOADING);
			return;
		}
	}
	else // ops... paitlib fail to load file... maybe is an PSP file?
	{
		if (ERR_NOERROR != ::LoadPSPFileToDIB(pFileName, hBitmap, (LPVOID *)&pBitmapBits))
		{
			::AfxMessageBox(IDS_ERRORLOADING);
			return;
		}
	}

	::ImgDeleteDIBSection(m_pImg);
	m_pImg= pImg;


	m_bmpDialog.DeleteObject();
	m_bmpDialog.Attach(hBitmap);

	// before using the UpdateLayeredWindow we have to 
	// pre-multiply the RGB channels with the alpha channel
	::PreMultiplyRGBChannels(m_bmpDialog, pBitmapBits);

	// now update the dummy dialog....
	DoUpdateDummyDialog(m_dlgDummy, m_bmpDialog, m_wndSlider.GetPos());
}

void CPerpixelalphaDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	if (m_bmpDialog.m_hObject)
		DoUpdateDummyDialog(m_dlgDummy, m_bmpDialog, m_wndSlider.GetPos());
	//CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
